int count = 0;
int group = 0;
//int current;// = 0;
//int count;// = 0;

void blinkI() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Blink Indv    ");

    group = 0;
    count = 0;
    programMillis = millis(); 
    runSetup = false;
  }

  //Serial.print(10, BYTE);
  if(programMillis+100 < millis()) {

    switch (group) {
      case 0:
        shiftColorRight((RGBW){255,0,0,0});
        break;
      case 1:
        shiftColorRight((RGBW){0,255,0,0});
        break;
      case 2:
        shiftColorRight((RGBW){0,0,255,0});
        break;
      case 3:
        shiftColorRight((RGBW){0,0,0,255});
        break;
    }
    count++;
    if(count == LED_COUNT) {
      count = 0;
      group++;
      if(group == 4) {  
        group = 0;
      }
    }
    programMillis = millis();
  }
}  

void solidColor() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.setCursor(3, 0);
    //        "              "
    lcd.print("Solid Color   ");
    
    runSetup = false;
  }  
   // lcd.print(redSlider,DEC);
   setAll((RGBW){redSlider,greenSlider,blueSlider,whiteSlider});
  // delay(100);
}
void rainbow() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Rainbow       ");
    
    programMillis = millis(); 
    runSetup = false;
    
    float h = 0.0;
    float s = 1.0;
    float v = .8; //.8
    
  }

  //Serial.print(10, BYTE);
//  if(programMillis+100 < millis()) {
 

   if(shiftDirection((RGBW) hsv_to_rgb(h,s,v)) == true){
     h += 6;
    if (h > 360.0){  
      h -= 360.0;
    } 
     
   }
  //  programMillis = millis();
  //}
}  
void shiftInColor() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Shift color");
    programMillis = millis(); 
    runSetup = false;
    
    float h = 0.0;
    float s = 1.0;
    float v = .8; //.8
    
  }

  //Serial.print(10, BYTE);
   shiftDirection((RGBW){redSlider,greenSlider,blueSlider,whiteSlider});
} 

void randomWhiteFlash() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Random Flash");
    programMillis = millis(); 
    runSetup = false;
    
  }
  //randomSeed(analogRead(10));
    //Serial.print(10, BYTE);
   shiftDirection((RGBW){redSlider,greenSlider,blueSlider,0});
   
    for(int i=0; i<LED_COUNT; i++) {
    //leds[i].w = 0;
    randomSeed(micros()+i*i);
    
    if(random(1,1024-randomPot) == 1) {
    if(LED_isFading(i) == 0){
     //leds[i].w = magnitudePot;
     
     LED_addFade(i,4, 0, magnitudePot, millis()+10, millis()+200);
     LED_addFade(i,4, magnitudePot, 0, millis()+200, millis()+400);
     
    }
  }
    }
} 

void fadeI() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Fade Indv    ");

    group = 0;
    count = 0;
    programMillis = millis(); 
    runSetup = false;
  }

  //Serial.print(10, BYTE);
  if(programMillis+200 < millis()) {
    uint32_t startMillis = millis() + 50;
    switch (group) {
      case 0:
        LED_addFade(count,1, 0, 255, startMillis, startMillis+1000);
        LED_addFade(count,1, 255, 0, startMillis+1000, startMillis+2000);

        break;
      case 1:
        
        LED_addFade(count,2, 0, 255, millis()+20, millis()+1000);
       LED_addFade(count,2, 255, 0, millis()+1000, millis()+2000);
        break;
      case 2:
        LED_addFade(count,3, 0, 255, millis()+20, millis()+1000);
        LED_addFade(count,3, 255, 0, millis()+1000, millis()+2000);
        break;
      case 3:
        LED_addFade(count,4, 0, 255, millis()+20, millis()+1000);
        LED_addFade(count,4, 255, 0, millis()+1000, millis()+2000);
        break;
    }
    count++;
    programMillis = millis();
    if(count == LED_COUNT) {
      count = 0;
      programMillis+=2000;
      group++;
      if(group == 3) {  
        group = 0;
      }
    }
    
  }
}  


void fadeSat() {
  if(runSetup == true) {
    clearAll();
    //print title
    lcd.print("Fade Hue    ");

    group = 0;
    count = 0;
    programMillis = millis(); 
    runSetup = false;
  }

  //Serial.print(10, BYTE);
  if(programMillis+200 < millis()) {
    uint32_t startMillis = millis();
        HSB base = RGBToHSB((RGBW){redSlider,greenSlider,blueSlider,whiteSlider});
        LED_addFade(count,5, base.h, base.h+magnitudePot, startMillis+10, startMillis+500);
        LED_addFade(count,5, base.h+magnitudePot, base.h, startMillis+500, startMillis+1000);

 
     
     count++;
    if(count == LED_COUNT) {
      count = 0;
      programMillis+=2000;
     //setAll((RGBW){redSlider,greenSlider,blueSlider,whiteSlider});
    }
    programMillis = millis();
}
}  



